rules:
  - id: okay-form-textarea-vue-component
    patterns:
      # See https://semgrep.dev/docs/writing-rules/rule-syntax/#options for
      # rationale for double ellipsis.
      - pattern-inside: import ... ... from '@gitlab/ui'
      - pattern: GlFormTextarea
    message: Correct usage of GlFormTextarea gitlab-ui component.
    languages:
      - generic
    severity: INFO
    paths:
      include:
        - '*.js'
        - '*.vue'
    metadata:
      componentLabel: 'component:form'
      pajamasCompliant: true

  - id: form-textarea-class-vue
    patterns:
      - pattern: gl-form-textarea
      - pattern-not-regex: </?gl-form-textarea
    message: |
      Detected usage of `gl-form-textarea` class inside JS/Vue file.
      Please use the `GlFormTextarea` component from `@gitlab/ui`.
    languages:
      - generic
    severity: ERROR
    paths:
      include:
        - '*.js'
        - '*.vue'
    metadata:
      componentLabel: 'component:form'
      pajamasCompliant: false
      epic: 'https://gitlab.com/groups/gitlab-org/-/epics/12676'

  - id: form-textarea-native-vue
    patterns:
      - pattern: <textarea ... >
      - pattern-not: <textarea ... class="... hidden ..." ... >
      - pattern-not: <textarea ... class="... js-task-list-field ..." ... >
      - pattern-not: <textarea ... class="... reply-placeholder-text-field ..." ... >
      - pattern-not: <textarea ... class="... gl-display-none ..." ... >
    message: |
      Detected usage of native textarea input inside Vue/JS file.
      Please consider using the `GlFormTextarea` component from `@gitlab/ui`.
    languages:
      - generic
    severity: ERROR
    options:
      generic_comment_style: cpp
      generic_ellipsis_max_span: 20
    paths:
      include:
        - '*.js'
        - '*.vue'
    metadata:
      componentLabel: 'component:form'
      pajamasCompliant: false
      epic: 'https://gitlab.com/groups/gitlab-org/-/epics/12676'
